/*****************************************************************************
 * PDSCANNER - A port scanner for GNOME                                      *
 * Copyright (C) 2000 Scott Guilbeaux <scottg@viptx.net>                     *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify      *
 * it under the terms of the GNU General Public License as published by      *
 * the Free Software Foundation; either version 2 of the License, or         *
 * (at your option) any later version.                                       *
 *                                                                           *
 * This program is distributed in the hope that it will be useful,           *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 * GNU General Public License for more details.                              *
 *                                                                           *
 * You should have received a copy of the GNU General Public License         *
 * along with this program; if not, write to the Free Software               *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *****************************************************************************/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef STDC_HEADERS
#include <stdio.h>
#include <stdlib.h>
#endif

#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif

#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif

#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif

#ifdef HAVE_ARPA_INET_H
#include <arpa/inet.h>
#endif

#ifdef HAVE_PTHREAD_H
#include <pthread.h>
#endif

#include <gnome.h>

#define COPYRIGHT "Copyright 2000 Scott Guilbeaux"
#define DESCRIPTION "PDSCANNER: A port scanner for GNOME.  Please report any bugs to the above email address."

typedef struct
{
   GtkWidget *main_window;
   GtkWidget *status_bar;
   GtkWidget *host_entry;
   GtkWidget *start_entry;
   GtkWidget *end_entry;
   GtkWidget *scan_button;
   GtkWidget *clear_button;
   GtkWidget *exit_button;
   GtkWidget *output_list;
   GtkProgress *progress_bar;
   pthread_t main_thread;
} pdscanner_t;

pdscanner_t pdscanner;

typedef struct
{
   gchar *host_name;
   gint starting_port;
   gint ending_port;
   gint current_port;
   gint valid;
} target_host_t;

target_host_t target_host;

gint thread_done;
struct hostent *hent;

/* interface.c prototypes */
void create_pdscanner(void);

/* callbacks.c prototypes */
void pdscanner_quit(GtkWidget *, GdkEvent *, gpointer);
void pdscanner_about(GtkWidget *, GdkEvent *, gpointer);
void pdscanner_scan(GtkWidget *, GdkEvent *, gpointer);
void pdscanner_clear(GtkWidget *, GdkEvent *, gpointer);

/* network.c prototypes */
void verify_host(void);
void check_port(struct hostent *);
void check_ports(void *);
